//
//  AppDelegate.m
//  MobNewsSDKApp
//
//  Created by 兵伍 on 2019/7/15.
//  Copyright © 2019 兵伍. All rights reserved.
//

#import "AppDelegate.h"
#import <MobNewsSDK/MobNewsSDK.h>
#import "PopTipView.h"
#import "RewardPopView.h"
#import "CustomCountDownView.h"
#import "SplashLogoView.h"
#import <MobADSDK/MobADSDKApi.h>

@interface AppDelegate ()<MobNewsSDKCallbackDelegate>
@property (nonatomic, strong) UIView *splashView;
@end

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    
    [self configAD];
    
    [self configNews];
    return YES;
}

- (void)configAD {
    // 创建初始化配置实例
    MobADConfigModel *cfg = [[MobADConfigModel alloc] init];
    // 渠道id，必填(由我司分配），下面的是测试用
    cfg.appId = @"ba0063bfbc1a5ad878";
    // SDK接入方的用户id（如果已登录）
    //config.thirdUserId = @"userId";
    // 初始化SDK
    BOOL result1 = [MobADSDKApi setupWithConfig:cfg];
    NSLog(@"MobADSDK setup success:%d", result1);
    NSLog(@"MobADSDK version:%@", [MobADSDKApi sdkVersion]);
}

- (void)configNews {
    // 创建初始化配置实例
    MobNewsConfigModel *config = [[MobNewsConfigModel alloc] init];
    // 渠道id，必填(由我司分配），下面的是测试用
    config.appId = @"ba0063bfbc1a5ad878";
    //config.mainTintColor = [UIColor colorWithRed:243/255.0 green:186/255.0 blue:74/255.0 alpha:1];
    // feed流下拉加载的背景色
    //config.pullRefreshTipBackColor = [UIColor redColor];
    // feed流下拉加载的提示语
    //config.pullRefreshTipText = @"为您推荐了%zd条更新";
    // feed流中如果标题包含过滤词，则不显示
    //config.feedFilter = [NSSet setWithObjects:@"恐怖", @"杀人", nil];
    // SDK接入方的用户id（如果已登录）
    //config.thirdUserId = @"userId";
    
#if 1
    // 设置自定义倒计时类（如果需要）
    config.CustomCountDownViewClass = [CustomCountDownView class];
#else
    // 定制内部默认倒计时UI（如果不设置，即使用默认ui）
    /*
    config.countDownViewBackgroundColor = [UIColor greenColor];
    config.countDownViewCircleColor = [UIColor redColor];
    config.countDownViewTextColor = [UIColor blueColor];
    config.countDownViewTextFont = [UIFont systemFontOfSize:25 weight:UIFontWeightSemibold];
     */
#endif
    // 初始化SDK
    BOOL result = [MobNewsSDKApi setupWithConfig:config];
    NSLog(@"LKADSDK setup result:%d", result);
    // 设置回调代理
    [MobNewsSDKApi setCallbackDelegate:self];
    NSLog(@"SDK version:%@", [MobNewsSDKApi sdkVersion]);
}

#pragma mark - 资讯详情回调
// 资讯详情加载成功回调
- (void)news_newsDetailDidLoadSuccessWithInfo:(NSDictionary *)info countDownView:(UIView<LKADCountDownViewProtocol> *)countDownView {
    NSLog(@"news detail load success:%@", info);
    NSString *type = info[@"type"];
    NSInteger duration = 5;
    // 可根据不同资讯类型设置不同时长
    NSInteger scrollDelay = 2;
    if ([type isEqualToString:@"Article"]) {
        duration = 5;
    } else if ([type isEqualToString:@"Video"]) {
        duration = 10;
        scrollDelay = 0;
    } else if ([type isEqualToString:@"Ad"]) {
        duration = 15;
    }
    
    CGSize ss = [UIScreen mainScreen].bounds.size;
    // App 判断是否需要显示倒计时
    BOOL needShow = YES;
    if (needShow) {
        // 开始倒计时并设置倒计时时长和位置
        [countDownView startWithDuration:duration frame:CGRectMake(ss.width - 100, ss.height - 200, 80, 80) scrollDelay:scrollDelay];
    }
}

// 资讯详情倒计时结束回调
- (void)news_newsDetailDidCountDownEndWithInfo:(NSDictionary *)info countDownView:(UIView<LKADCountDownViewProtocol> *)countDownView {
    NSLog(@"news detail count down end:%@", info);
    
    // 模拟网络请求
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        // 根据请求结果显示奖励提示
        [countDownView showRewardWithInfo:[NSString stringWithFormat:@"+%d", arc4random_uniform(10)]];
    });
}

- (void)news_newsDetailCountDownViewDidClick:(UIView<LKADCountDownViewProtocol> *)countDownView {
    NSLog(@"count down view did click");
}

- (void)news_newsDetailDidCloseWithInfo:(NSDictionary *)info {
    NSLog(@"news detail did close:%@", info);
}

@end
