//
//  LKADRewardPopView.m
//  LKADSDK
//
//  Created by 兵伍 on 2019/9/6.
//  Copyright © 2019 兵伍. All rights reserved.
//

#import "RewardPopView.h"

@interface RewardPopView()
@property (nonatomic, assign) NSInteger duration;
@property (nonatomic, weak) IBOutlet UIImageView *backImageView;
@property (nonatomic, weak) IBOutlet UILabel *titleLabel;
//@property (nonatomic, weak) IBOutlet UIButton *btn;
@end

@implementation RewardPopView

+ (void)showOnWindowWithDuration:(NSInteger)duration info:(NSDictionary *)info {
    UIView *view = [UIApplication sharedApplication].keyWindow;
    [self showOn:view duration:duration info:info];
}

+ (void)showOn:(UIView *)view duration:(NSInteger)duration info:(NSDictionary *)info {
    if (!view) {
        return;
    }
    
    RewardPopView *popView = [RewardPopView loadViewFromXib];
    popView.center = CGPointMake(view.bounds.size.width / 2.0, view.bounds.size.height / 2.0);
    popView.duration = duration;
    NSString *text = info[@"text"];
    if (text) {
        popView.titleLabel.text = text;
    }
    
    UIView *mask = [[UIView alloc] initWithFrame:view.bounds];
    mask.backgroundColor = [UIColor colorWithWhite:0 alpha:0.7];
    mask.tag = 2019090610;
    [mask addSubview:popView];
    [view addSubview:mask];
    
    mask.alpha = 0.01;
    [UIView animateWithDuration:0.25 animations:^{
        mask.alpha = 1;
    } completion:^(BOOL finished) {
        
    }];
}

//- (IBAction)sureBtnClicked:(id)sender {
//    [self dismiss];
//}

+ (instancetype)loadViewFromXib {
    NSString *className = NSStringFromClass([self class]);
    NSArray *tmpArray = [[NSBundle mainBundle] loadNibNamed:className owner:nil options:nil];
    if (tmpArray.count > 0)
    {
        return tmpArray[0];
    }
    return nil;
}

- (void)awakeFromNib {
    [super awakeFromNib];
    self.backgroundColor = [UIColor clearColor];
    self.backImageView.backgroundColor = [UIColor clearColor];
}

- (void)dismiss {
    UIView *mask = self.superview;
    if (mask.tag == 2019090610) {
        [UIView animateWithDuration:0.25 animations:^{
            mask.alpha = 0.01;
        } completion:^(BOOL finished) {
            [mask removeFromSuperview];
        }];
    } else {
        [self removeFromSuperview];
    }
}

- (void)dealloc {
    NSLog(@"%s", __func__);
}

- (void)setDuration:(NSInteger)duration {
    if (duration < 0) {
        return;
    }
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(dismiss) object:nil];
    [self performSelector:@selector(dismiss) withObject:nil afterDelay:duration];
}

@end
